using System;

namespace Sharp3D
{
	public class Image
	{
		private byte[] data;
		private int width, height;

		public Image(string fileName)
		{
			// Read an bitmap file from disk
			System.Drawing.Bitmap bitmap = new System.Drawing.Bitmap(fileName);

			this.width = bitmap.Width;
			this.height = bitmap.Height;

			this.data = new byte[4*width*height];

			int adr = 0;
			for (int y = 0; y < height; y++)
			{
				for (int x = 0; x < width; x++)
				{
					// Retrieve RGBA pixel value from bitmap
					System.Drawing.Color color = bitmap.GetPixel(x, y);

					data[adr  ] = color.R;
					data[adr+1] = color.G;
					data[adr+2] = color.B;
					data[adr+3] = color.A;

					adr += 4;
				}
			}
		}

		public int Width
		{
			get
			{
				return width;
			}
		}

		public int Height
		{
			get
			{
				return height;
			}
		}

		public Color this[int x, int y]
		{
			get
			{
				int adr = 4*(y*width + x);

				return new Color(data[adr], data[adr+1], data[adr+2], data[adr+3]);
			}
		}
	}
}
