using System;

namespace Sharp3D 
{
	public class Point2D
	{
		// logical coordinates from left bottom (-1, -1) to right top (1, 1)
		public double X, Y;

		public Point2D() {
			X = 0.0;
			Y = 0.0;
		}

		public Point2D(double x, double y)
		{
			X = x;
			Y = y;
		}

		public Point2D(Point2D point)
		{
			X = point.X;
			Y = point.Y;
		}

		public static Point2D operator+ (Point2D pointL, Point2D pointR)
		{
			return new Point2D(pointL.X + pointR.X, pointL.Y + pointR.Y);
		}

		public static Point2D operator- (Point2D pointL, Point2D pointR)
		{
			return new Point2D(pointL.X - pointR.X, pointL.Y - pointR.Y);
		}

		public static Point2D operator* (double val, Point2D point)
		{
			return new Point2D(val * point.X, val * point.Y);
		}
	}
}
