using System;

namespace Sharp3D
{
	public class Point3D
	{
		public double X, Y, Z;

		public Point3D()
		{
			X = 0.0;
			Y = 0.0;
			Z = 0.0;
		}

		public Point3D(double x, double y, double z)
		{
			X = x;
			Y = y;
			Z = z;
		}

		public Point3D(Point3D point)
		{
			X = point.X;
			Y = point.Y;
			Z = point.Z;
		}

		public static Vector3D operator- (Point3D pointL, Point3D pointR)
		{
			return new Vector3D(pointL.X - pointR.X, pointL.Y - pointR.Y, pointL.Z - pointR.Z);
		}

		public static Point3D operator+ (Point3D point, Vector3D vector)
		{
			return new Point3D(point.X + vector.X, point.Y + vector.Y, point.Z + vector.Z);
		}

		public static Point3D operator- (Point3D point, Vector3D vector)
		{
			return new Point3D(point.X - vector.X, point.Y - vector.Y, point.Z - vector.Z);
		}
	}
}
