using System;
using System.Collections;

namespace Sharp3D
{
	public class Polygon2D : IEnumerable
	{
		private ArrayList points;

		public Polygon2D()
		{
			points = new ArrayList();
		}

		public void Add(Point2D p)
		{
			points.Add(p);
		}

		public void Clear()
		{
			points.Clear();
		}

		public int Size
		{
			get
			{
				return points.Count;
			}
		}

		private class Polygon2DEnumerator : IEnumerator
		{
			private ArrayList points;
			private int i;

			public Polygon2DEnumerator(ArrayList points)
			{
				this.points = points;
				Reset();
			}

			public void Reset()
			{
				i = -1;
			}

			public object Current
			{
				get
				{
					return points[i];
				}
			}

			public bool MoveNext()
			{
				i++;
				return i < points.Count;
			}
		}

		public IEnumerator GetEnumerator()
		{
			return new Polygon2DEnumerator(points);
		}

		public Point2D this[int n]
		{
			get
			{
				return (Point2D)points[n];
			}

			set
			{
				points[n] = value;
			}
		}
	}
}
