using System;

namespace Sharp3D
{
	public class SpecularPixelShader : IPixelShader
	{
		public Color calculate(Material material, Vector3D t0, Vector3D t1, Vector3D t2)
		{
			// normal and half vector
			Vector3D normal = t0.GetNormalized();
			Vector3D halfVec = t1.GetNormalized();

			double intensity = Math.Pow(Math.Max(normal * halfVec, 0.0), 13.0);

			int c = Math.Min((int)(255.0*intensity), 255);

			return new Color(c, c, c);
		}
	}
}
